﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private PosL As PointApi 
	Private PosResult As PointApi
	Private ArmWdt, FArmWdt As Double
	Private ShoulderAxis As PointApi
	Private Angle(2) As Double
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aWdt As Double, faWdt As Double, SAxisX As Double, SAxisY As Double)
	ArmWdt = aWdt
	FArmWdt = faWdt
	ShoulderAxis.X = SAxisX
	ShoulderAxis.Y = SAxisY	
End Sub

Public Sub Calc(p As PointApi) As Double()
	Angle(0) = -500
	PosL = p
	Dim bl As Boolean  
	bl = calcDistances
	If bl Then
		Angle(0) = CalcAngleD(PosResult.X, PosResult.Y, PosL.X, PosL.Y)
		Angle(1) = CalcAngleD(ShoulderAxis.X, ShoulderAxis.Y, PosResult.X, PosResult.Y)
	End If
	Return Angle
End Sub

 Private Sub calcDistances() As Boolean
    Dim dx As Float = PosL.x - ShoulderAxis.X
    Dim dy As Float = PosL.Y - ShoulderAxis.Y
    Dim dist As Double = Sqrt(dx * dx + dy * dy)
    ' See how many solutions there are.
    If (dist > ArmWdt + FArmWdt) Then
        'Log("No solutions, The distance is longer than the arm length.")
		Return False
    Else If (dist < Abs(ArmWdt - FArmWdt)) Then
		'Log("No solutions.")
        Return False
    Else
        Dim a As Double = (Power(FArmWdt, 2) - Power(ArmWdt, 2) + Power(dist, 2)) / (2 * dist)
        Dim h As Double = Sqrt(Power(FArmWdt, 2) - Power(a, 2))
        ' Find P2.
        Dim cx2 As Double = PosL.X + a * (ShoulderAxis.X - PosL.X) / dist
        Dim cy2 As Double =  PosL.Y + a * (ShoulderAxis.Y -  PosL.Y) / dist

        ' Get the result points
		PosResult.X = cx2 + h * (ShoulderAxis.Y - PosL.Y) / dist
        PosResult.Y = cy2 - h * (ShoulderAxis.X - PosL.X) / dist
        Return True
    End If
End Sub

Public Sub CalcAngleD(aX As Double, aY As Double, bX As Double, bY As Double) As Double
    Dim dirX = bX - aX As Double
    Dim dirY = bY - aY As Double
	Return ATan2D(dirY, dirX)
End Sub

